/**
 * @author alteredq / http://alteredqualia.com/
 * @authod mrdoob / http://mrdoob.com/
 * @authod arodic / http://aleksandarrodic.com/
 * @authod fonserbc / http://fonserbc.github.io/
 */
THREE.StereoEffect = function(renderer, stType) {
    this.setSize = function(width, height) {
        renderer.setSize(width, height);
    };
    this.render0 = function(scene, camera, eyemode) {
        scene.updateMatrixWorld();
        if (camera.parent === null) camera.updateMatrixWorld();
        var size = renderer.getSize();
        renderer.setScissorTest(true);
        renderer.clear();
        var sw;
        if (stType == 0) {
	        renderer.setScissor(0, 0, size.width, size.height);
	        renderer.setViewport(0, 0, size.width, size.height);
			}
        else {
	        renderer.setScissor(0, 0, size.width/2, size.height);
	   //     renderer.setViewport(0, 0, size.width/2, size.height);
        	renderer.setViewport(size.width/2-size.width*zoomfac/200, size.height-size.height*zoomfac/100, size.width*zoomfac/200, size.height*zoomfac/100);
			}
        renderer.render(scene, camera);
    };
    this.render = function(scene, camera, eyemode) {
        if (stType == 0) return;
        var size = renderer.getSize();
        renderer.setScissor(size.width / 2, 0, size.width / 2, size.height);
    //    renderer.setViewport(size.width / 2, 0, size.width / 2, size.height);
		renderer.setViewport(size.width / 2, size.height-size.height*zoomfac/100, size.width*zoomfac/200, size.height*zoomfac/100);
        renderer.render(scene, camera);
        renderer.setScissorTest(false);
    };
    this.dispose = function() {};
};
THREE.ParallaxBarrierEffect = function(renderer, width, height) {
    var _camera = new THREE.OrthographicCamera(-1, 1, 1, -1, 0, 1);
    var _scene = new THREE.Scene();
    var _params = {
        minFilter: THREE.LinearFilter,
        magFilter: THREE.NearestFilter,
        format: THREE.RGBAFormat
    };
    var _renderTargetL = new THREE.WebGLRenderTarget(width, height, _params);
    var _renderTargetR = new THREE.WebGLRenderTarget(width, height, _params);
    var _material = new THREE.ShaderMaterial({
        uniforms: {
            "mapLeft": {
                type: "t",
                value: _renderTargetL
            },
            "mapRight": {
                type: "t",
                value: _renderTargetR
            }
        },
        vertexShader: ["varying vec2 vUv;", "void main() {",
            "	vUv = vec2( uv.x, uv.y );",
            "	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );",
            "}"
        ].join("\n"),
        fragmentShader: ["uniform sampler2D mapLeft;",
            "uniform sampler2D mapRight;", "varying vec2 vUv;",
            "void main() {", "	vec2 uv = vUv;",
            "	if ( ( mod( gl_FragCoord.y, 2.0 ) ) > 1.00 ) {",
            "		gl_FragColor = texture2D( mapLeft, uv );",
            "	} else {",
            "		gl_FragColor = texture2D( mapRight, uv );", "	}",
            "}"
        ].join("\n")
    });
    var mesh = new THREE.Mesh(new THREE.PlaneBufferGeometry(2, 2),
        _material);
    _scene.add(mesh);
    this.setSize = function(width, height) {
        renderer.setSize(width, height);
        var pixelRatio = renderer.getPixelRatio();
        _renderTargetL.setSize(width * pixelRatio, height * pixelRatio);
        _renderTargetR.setSize(width * pixelRatio, height * pixelRatio);
    };
    this.render0 = function(scene, camera, bSwap) {
        scene.updateMatrixWorld();
        if (camera.parent === null) camera.updateMatrixWorld();
        renderer.render(scene, camera, _renderTargetL, true);
    };
    this.render = function(scene, camera, bSwap) {
        renderer.render(scene, camera, _renderTargetR, true);
        renderer.render(_scene, _camera);
    };
    this.dispose = function() {
        if (_renderTargetL) _renderTargetL.dispose();
        if (_renderTargetR) _renderTargetR.dispose();
        _scene.remove(mesh);
        _material.dispose();
    };
};
THREE.ParallaxBarrierEffect2 = function(renderer, width, height) {
    var _camera = new THREE.OrthographicCamera(-1, 1, 1, -1, 0, 1);
    var _scene = new THREE.Scene();
    var _params = {
        minFilter: THREE.LinearFilter,
        magFilter: THREE.NearestFilter,
        format: THREE.RGBAFormat
    };
    var _renderTargetL = new THREE.WebGLRenderTarget(width, height, _params);
    var _renderTargetR = new THREE.WebGLRenderTarget(width, height, _params);
    var _material = new THREE.ShaderMaterial({
        uniforms: {
            "mapLeft": {
                type: "t",
                value: _renderTargetL
            },
            "mapRight": {
                type: "t",
                value: _renderTargetR
            }
        },
        vertexShader: ["varying vec2 vUv;", "void main() {",
            "	vUv = vec2( uv.x, uv.y );",
            "	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );",
            "}"
        ].join("\n"),
        fragmentShader: ["uniform sampler2D mapLeft;",
            "uniform sampler2D mapRight;", "varying vec2 vUv;",
            "void main() {", "	vec2 uv = vUv;",
	    "	if ( gl_FragCoord.x > 2048.0 ) {",
 	    "	gl_FragColor = vec4(0.2,0.2,0.2,1.0);}",
            "	else if ( ( mod( gl_FragCoord.x, 2.0 ) ) > 0.80 ) {",
            "		gl_FragColor = texture2D( mapRight, uv );",
            "	} else {",
            "		gl_FragColor = texture2D( mapLeft, uv );", "	}",
            "}"
        ].join("\n")
    });
    var mesh = new THREE.Mesh(new THREE.PlaneBufferGeometry(2, 2),
        _material);
    _scene.add(mesh);
    this.setSize = function(width, height) {
        renderer.setSize(width, height);
        var pixelRatio = renderer.getPixelRatio();
        _renderTargetL.setSize(width * pixelRatio, height * pixelRatio);
        _renderTargetR.setSize(width * pixelRatio, height * pixelRatio);
    };
    this.render0 = function(scene, camera, bSwap) {
        scene.updateMatrixWorld();
        if (camera.parent === null) camera.updateMatrixWorld();
        renderer.render(scene, camera, _renderTargetL, true);
    };
    this.render = function(scene, camera, bSwap) {
        renderer.render(scene, camera, _renderTargetR, true);
        renderer.render(_scene, _camera);
    };
    this.dispose = function() {
        if (_renderTargetL) _renderTargetL.dispose();
        if (_renderTargetR) _renderTargetR.dispose();
        _scene.remove(mesh);
        _material.dispose();
    };
};
THREE.AnaglyphEffect = function(renderer, stType) {
    // Matrices generated with angler.js https://github.com/tschw/angler.js/
    // (in column-major element order, as accepted by WebGL)
    if (stType == 2) {
        this.colorMatrixLeft = new THREE.Matrix3().fromArray([
            0.299, 0, 0, // r out
            0.587, 0, 0, // g out
            0.114, 0, 0 // b out
        ]);
        //		red						green 						blue  						in
        this.colorMatrixRight = new THREE.Matrix3().fromArray([
            0, 0.299, 0.299, // r out
            0, 0.587, 0.587, // g out
            0, 0.114, 0.114 // b out
        ]);
    } else if (stType == 1) {
        this.colorMatrixLeft = new THREE.Matrix3().fromArray([
            1, 0, 0, // r out
            0, 0, 0, // g out
            0, 0, 0 // b out
        ]);
        //		red						green 						blue  						in
        this.colorMatrixRight = new THREE.Matrix3().fromArray([
            0, 0, 0, // r out
            0, 1, 0, // g out
            0, 0, 1 // b out
        ]);
    } else {
        this.colorMatrixLeft = new THREE.Matrix3().fromArray([
            0.456100, -0.0400822, -0.0152161, // r out
            0.500484, -0.0378246, -0.0205971, // g out
            0.176381, -0.0157589, -0.00546856 // b out
        ]);
        //		red						green 						blue  						in
        this.colorMatrixRight = new THREE.Matrix3().fromArray([-0.0434706,
            0.378476, -0.0721527, // r out
            -0.0879388, 0.73364, -0.112961, // g out
            -0.00155529, -0.0184503, 1.2264 // b out
        ]);
    }
    var _camera = new THREE.OrthographicCamera(-1, 1, 1, -1, 0, 1);
    var _scene = new THREE.Scene();
    var _params = {
        minFilter: THREE.LinearFilter,
        magFilter: THREE.NearestFilter,
        format: THREE.RGBAFormat
    };
    var _renderTargetL = new THREE.WebGLRenderTarget(512, 512, _params);
    var _renderTargetR = new THREE.WebGLRenderTarget(512, 512, _params);
    var _material = new THREE.ShaderMaterial({
        uniforms: {
            "mapLeft": {
                type: "t",
                value: _renderTargetL
            },
            "mapRight": {
                type: "t",
                value: _renderTargetR
            },
            "colorMatrixLeft": {
                type: "m3",
                value: this.colorMatrixLeft
            },
            "colorMatrixRight": {
                type: "m3",
                value: this.colorMatrixRight
            }
        },
        vertexShader: ["varying vec2 vUv;", "void main() {",
            "	vUv = vec2( uv.x, uv.y );",
            "	gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );",
            "}"
        ].join("\n"),
        fragmentShader: ["uniform sampler2D mapLeft;",
            "uniform sampler2D mapRight;", "varying vec2 vUv;",
            "uniform mat3 colorMatrixLeft;",
            "uniform mat3 colorMatrixRight;",
            // These functions implement sRGB linearization and gamma correction
            "float lin( float c ) {",
            "	return c <= 0.04045 ? c * 0.0773993808 :",
            "			pow( c * 0.9478672986 + 0.0521327014, 2.4 );",
            "}", "vec4 lin( vec4 c ) {",
            "	return vec4(  c.r ,  c.g ,  c.b , c.a );", "}",
            "float dev( float c ) {",
            "	return c <= 0.0031308 ? c * 12.92",
            "			: pow( c, 0.41666 ) * 1.055 - 0.055;", "}",
            "void main() {", "	vec2 uv = vUv;",
            "	vec4 colorL = lin( texture2D( mapLeft, uv ) );",
            "	vec4 colorR = lin( texture2D( mapRight, uv ) );",
            "	vec3 color = clamp(",
            "			colorMatrixLeft * colorL.rgb +",
            "			colorMatrixRight * colorR.rgb, 0., 1. );",
            "	gl_FragColor = vec4(",
            "			 color.r ,  color.g ,  color.b ,",
            "			max( colorL.a, colorR.a ) );", "}"
        ].join("\n")
    });
    var mesh = new THREE.Mesh(new THREE.PlaneBufferGeometry(2, 2),
        _material);
    _scene.add(mesh);
    this.setSize = function(width, height) {
        renderer.setSize(width, height);
        var pixelRatio = renderer.getPixelRatio();
        _renderTargetL.setSize(width * pixelRatio, height * pixelRatio);
        _renderTargetR.setSize(width * pixelRatio, height * pixelRatio);
    };
    this.render0 = function(scene, camera, bSwap) {
        scene.updateMatrixWorld();
        if (camera.parent === null) camera.updateMatrixWorld();
        renderer.render(scene, camera, _renderTargetL, true);
    };
    this.render = function(scene, camera, bSwap) {
        renderer.render(scene, camera, _renderTargetR, true);
        renderer.render(_scene, _camera);
    };
    this.dispose = function() {
        if (_renderTargetL) _renderTargetL.dispose();
        if (_renderTargetR) _renderTargetR.dispose();
        _scene.remove(mesh);
        _material.dispose();
    };
};
